/*
 *	pieceif.c - WinUSBP/ECEfoCXhCoppieceif.dll
 *	Copyright(C) 2009 Naoyuki Sawa
 *
 *	* Sun Nov 29 12:57:44 JST 2009 Naoyuki Sawa
 *	- 1st [XB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <windows.h>
#include <setupapi.h>	/* setupapi.lib */
#include <winusb.h>	/* winusb.lib */

#define NOPCESPRINTF
#define __PCEKN__
#include "piece.h"
#define INDLL
#include "pieceif.h"

/****************************************************************************
 *	
 ****************************************************************************/

static int usbOpen(const GUID* InterfaceClassGuid, int MemberIndex, HANDLE* pDeviceInterfaceHandle, WINUSB_INTERFACE_HANDLE* pWinUsbInterfaceHandle) {
	int Result = -1; /* s */
	/* foCXZbg擾܂B */
	HDEVINFO DeviceInfoSet;
	DeviceInfoSet = SetupDiGetClassDevs(InterfaceClassGuid, NULL, NULL, DIGCF_INTERFACEDEVICE | DIGCF_PRESENT);
	if(DeviceInfoSet != INVALID_HANDLE_VALUE) {
		/* foCXC^[tFCX擾܂B */
		SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
		DeviceInterfaceData.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);
		if(SetupDiEnumDeviceInterfaces(DeviceInfoSet, NULL, InterfaceClassGuid, MemberIndex, &DeviceInterfaceData)) {
			/* foCXC^[tFCXڍ׏擾܂B */
			DWORD RequiredSize;
			if(!SetupDiGetDeviceInterfaceDetail(DeviceInfoSet, &DeviceInterfaceData, NULL, 0, &RequiredSize, NULL) && (GetLastError() == ERROR_INSUFFICIENT_BUFFER)) {
				SP_DEVICE_INTERFACE_DETAIL_DATA* DeviceInterfaceDetailData;
				DeviceInterfaceDetailData = malloc(RequiredSize);
				if(DeviceInterfaceDetailData) {
					DeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
					if(SetupDiGetDeviceInterfaceDetail(DeviceInfoSet, &DeviceInterfaceData, DeviceInterfaceDetailData, RequiredSize, NULL, NULL)) {
						/* foCXnh擾܂B */
						HANDLE DeviceInterfaceHandle;
						DeviceInterfaceHandle = CreateFile(
							DeviceInterfaceDetailData->DevicePath,
							GENERIC_READ | GENERIC_WRITE,
							0,			/* LsƂ */
							NULL,
							OPEN_EXISTING,
							FILE_FLAG_OVERLAPPED,	/* WinUsb_Initialize()̂߂ɕKv */
							NULL);
						if(DeviceInterfaceHandle != INVALID_HANDLE_VALUE) {
							/* WinUsbnh擾܂B */
							WINUSB_INTERFACE_HANDLE WinUsbInterfaceHandle;
							if(WinUsb_Initialize(DeviceInterfaceHandle, &WinUsbInterfaceHandle)) {
								/* foCXnhƁAWinUsbnhi[܂B */
								*pDeviceInterfaceHandle = DeviceInterfaceHandle;
								*pWinUsbInterfaceHandle = WinUsbInterfaceHandle;
								Result = 0; /*  */
							}
						} else {
							/* WinUsbnh̎擾ɎsAfoCXnhJ܂B */
							CloseHandle(DeviceInterfaceHandle);
						}
					}
					/* foCXC^[tFCXڍ׏͂svȂ̂ŁAJ܂B */
					free(DeviceInterfaceDetailData);
				}
			}
		}
		/* foCXZbg͂svȂ̂ŁAJ܂B */
		SetupDiDestroyDeviceInfoList(DeviceInfoSet);
	}
	return Result;
}

/****************************************************************************
 *	
 ****************************************************************************/

/* 0 Version */
int DLLAPI ismGetVersion(void* ptr, int renew) {
	static SYSTEMINFO si;
	if(renew) {
		static const unsigned char tmp[2] = { 0, 32 };
		if(ismCmdR(tmp, 2, &si, 32) != 0) {
			si.bios_ver = PIECE_INVALID_VERSION;
		}
	}
	if(ptr) {
		memcpy(ptr, &si, 32);
	}
	return si.bios_ver;
}

/* 1 Execute */
int DLLAPI ismExec(unsigned long adrs) {
	unsigned char tmp[9] = { 1 };
	*(unsigned long*)&tmp[1] = adrs;
	return ismCmdW(tmp, 5, 0, 0);
}

/* 2 Read Cont. */
int DLLAPI ismReadMem(unsigned char* pBuff, unsigned long adrs, unsigned len) {
	unsigned char tmp[9] = { 2 };
	*(unsigned long*)&tmp[1] = adrs;
	*(unsigned long*)&tmp[5] = len;
	return ismCmdR(tmp, 9, pBuff, len);
}

/* 3 Write Cont. */
int DLLAPI ismWriteMem(const unsigned char* pBuff, unsigned long adrs, unsigned len) {
	unsigned char tmp[9] = { 3 };
	*(unsigned long*)&tmp[1] = adrs;
	*(unsigned long*)&tmp[5] = len;
	return ismCmdW(tmp, 9, pBuff, len);
}

/* 4 Set App Status. */
int /*DLLAPI*/ ismSetAppStat(int stat) {
	unsigned char tmp[2] = { 4, stat };
	return ismCmdW(tmp, 2, 0, 0);
}

/* 5 Get App Status. */
int /*DLLAPI*/ ismGetAppStat(int* ret) {
	unsigned char tmp[2] = { 5 };
	int err;
	if((err = ismCmdR(tmp, 1, tmp, 2)) != 0) {
		return err; /* s */
	}
	*ret = *(unsigned short*)tmp;
	return 0; /*  */
}

/* 6 Get Wave Buff Status. */
int /*DLLAPI*/ ismGetWaveStat(int ch, int* ret) {
	unsigned char tmp[2] = { 6, ch };
	int err;
	if((err = ismCmdR(tmp, 2, tmp, 2)) != 0) {
		return err; /* s */
	}
	*ret = *(unsigned short*)tmp;
	return 0; /*  */
}

/* 7 Out Wave Data. */
int /*DLLAPI*/ ismWaveOut(int ch, unsigned long adrs) {
	unsigned char tmp[6] = { 7, ch };
	*(unsigned long*)&tmp[2] = adrs;
	return ismCmdW(tmp, 6, 0, 0);
}

/* 8 FlashErase */
int /*DLLAPI*/ ismFlashErase(unsigned long adrs, int* ret) {
	unsigned char tmp[5] = { 8 };
	int err;
	*(unsigned long*)&tmp[1] = adrs;
	if((err = ismCmdR(tmp, 5, tmp, 2)) != 0) {
		return err; /* s */
	}
	*ret = *(unsigned short*)tmp;
	printf("FlashErase %x %x\n", adrs, *ret);
	return 0; /*  */
}

/* 9 FlashWrite */
int /*DLLAPI*/ ismFlashWrite(unsigned long dadrs, unsigned long sadrs, unsigned len, int* ret) {
	unsigned char tmp[13] = { 9 };
	int err;
	*(unsigned long*)&tmp[1] = dadrs;
	*(unsigned long*)&tmp[5] = sadrs;
	*(unsigned long*)&tmp[9] = len;
	if((err = ismCmdR(tmp, 13, tmp, 2)) != 0) {
		return err; /* s */
	}
	*ret = *(unsigned short*)tmp;
	printf("FlashWrite %x %x %x %x\n", dadrs, sadrs, len, *ret);
	return 0; /*  */
}

/* 10 USBCOM Read */
int DLLAPI ismUCRead(void* ptr, int len) {
	static const unsigned char tmp[1] = { 10 };
	return ismCmdR(tmp, 1, ptr, len);
}

/* 11 USBCOM Write */
int DLLAPI ismUCWrite(void* ptr, int len) {
	static const unsigned char tmp[1] = { 11 };
	return ismCmdW(tmp, 1, ptr, len);
}

/* 12 USBCOM Get Stat. */
int DLLAPI ismUCGetStat(USBCOMS* pucs) {
	static const unsigned char tmp[1] = { 12 };
	return ismCmdR(tmp, 1, pucs, 12);
}

/* 13 USBCOM Open */
int DLLAPI ismUCOpen(USBCOMS* pucs) {
	static const unsigned char tmp[1] = { 13 };
	return ismCmdR(tmp, 1, pucs, 12 + 16);
}

/* 14 USBCOM Close */
int DLLAPI ismUCClose() {
	static unsigned char tmp[1] = { 14 };
	return ismCmdR(tmp, 1, tmp, 1);
}

/* 15 Set RTC */
int DLLAPI ismRTCSet(int year, int mon, int day, int hour, int min, int sec) {
	unsigned char tmp[10] = { 15 };
	PCETIME* ppt = (PCETIME*)&tmp[2];
	ppt->yy = year;
	ppt->mm = mon;
	ppt->dd = day;
	ppt->hh = hour;
	ppt->mi = min;
	ppt->ss = sec;
	ppt->s100 = 0;
	return ismCmdW(tmp, 10, 0, 0);
}

/* 16 App Pause */
int /*DLLAPI*/ ismAppPause(int pausef) {
	unsigned char tmp[2] = { 16, pausef };
	return ismCmdW(tmp, 2, 0, 0);
}

/* 17 LCDGetInfo */
int /*DLLAPI*/ ismLCDGetInfo(int* pstat, unsigned long* pbuff) {
	unsigned char tmp[12] = { 17 };
	int err;
	if((err = ismCmdR(tmp, 1, tmp, 12)) != 0) {
		return err; /* s */
	}
	*pstat = tmp[0];
	*pbuff = *(unsigned long*)&tmp[8];
	return 0; /*  */
}

/* 18 Get Heap top. */
int DLLAPI ismHeapGetAdrs(unsigned long* padr) {
	static const unsigned char tmp[1] = { 18 };
	return ismCmdR(tmp, 1, padr, 4);
}

/****************************************************************************
 *	
 ****************************************************************************/

#include <initguid.h>
// {77113379-ADB1-4293-A33D-DE2E19BC43F5}
DEFINE_GUID(GUID_CLASS_PIECE_DRIVER_WINUSB,
0x77113379, 0xadb1, 0x4293, 0xa3, 0x3d, 0xde, 0x2e, 0x19, 0xbc, 0x43, 0xf5);

typedef struct tagUSBHANDLES {
	HANDLE hdev;
	WINUSB_INTERFACE_HANDLE husb;
} USBHANDLES;
static USBHANDLES usbhandles[PIECE_MAX_DEVICES/*=22*/] = {
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  0
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  1
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  2
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  3
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  4
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  5
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  6
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  7
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  8
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, //  9
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 10
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 11
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 12
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 13
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 14
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 15
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 16
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 17
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 18
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 19
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 20
	{ INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE }, // 21
};
static USBHANDLES* curusb = &usbhandles[0];

/*--------------------------------------------------------------------------*/

int DLLAPI ismInit() {
	return ismInitEx(0, PIECE_DEF_WAITN);
}

int DLLAPI ismInitEx(int devno, int waitn) {
	int err;
	if(devno >= PIECE_MAX_DEVICES) {
		return ERR_PIECEIF_OVER_DEVICES;
	}
	curusb = &usbhandles[devno];
	if(curusb->husb != INVALID_HANDLE_VALUE) { /* ɏĂ */
		return 0; /*  */
	}
	if((err = usbOpen(&GUID_CLASS_PIECE_DRIVER_WINUSB, 0, &curusb->hdev, &curusb->husb)) != 0) {
		return err; /* s */
	}
	if(ismGetVersion(NULL, 1) == PIECE_INVALID_VERSION) {
		return 1; /* s */
	}
	return 0; /*  */
}

int DLLAPI ismExit() {
	int devno;
	for(devno = 0; devno < PIECE_MAX_DEVICES; devno++) {
		USBHANDLES* pu = &usbhandles[devno];
		if(pu->husb != INVALID_HANDLE_VALUE) {
			ismExitEx(devno);
		}
	}
	return 0; /*  */
}

int DLLAPI ismExitEx(int devno) {
	USBHANDLES* pu;
	if(devno >= PIECE_MAX_DEVICES) {
		return ERR_PIECEIF_OVER_DEVICES; /* s */
	}
	pu = &usbhandles[devno];
	if(pu->husb != INVALID_HANDLE_VALUE) {
		fprintf(stderr, "Exit USB#%d\n", devno);
		WinUsb_Free(curusb->husb);
		curusb->husb = INVALID_HANDLE_VALUE;
		CloseHandle(curusb->hdev);
		curusb->hdev = INVALID_HANDLE_VALUE;
	}
	return 0; /*  */
}

int DLLAPI ismSelect(int devno) {
	USBHANDLES* pu;
	if(devno >= PIECE_MAX_DEVICES) {
		return ERR_PIECEIF_OVER_DEVICES;
	}
	pu = &usbhandles[devno];
	if(pu->husb == INVALID_HANDLE_VALUE) {
		return 1; /* s */
	}
	curusb = pu;
	return 0; /*  */
}

int DLLAPI ismCmdW(const void* ptr1, unsigned len1, const void* ptr2, unsigned len2) {
	ULONG len3;
	if(curusb->husb == INVALID_HANDLE_VALUE) {
		return 1; /* s */
	}
	if(!WinUsb_WritePipe(curusb->husb, 0x02/*EP2OUT*/, (void*)ptr1, len1, &len3, NULL) || (len1 != len3)) {
		return 1; /* s */
	}
	if(len2) {
		if(!WinUsb_WritePipe(curusb->husb, 0x02/*EP2OUT*/, (void*)ptr2, len2, &len3, NULL) || (len2 != len3)) {
			return 1; /* s */
		}
	}
	return 0; /*  */
}

int DLLAPI ismCmdR(const void* ptr1, unsigned len1, void* ptr2, unsigned len2) {
	ULONG len3;
	if(curusb->husb == INVALID_HANDLE_VALUE) {
		return 1; /* s */
	}
	if(!WinUsb_WritePipe(curusb->husb, 0x02/*EP2OUT*/, (void*)ptr1, len1, &len3, NULL) || (len1 != len3)) {
		return 1; /* s */
	}
	if(len2) {
		if(!WinUsb_ReadPipe(curusb->husb, 0x82/*EP2IN*/, ptr2, len2, &len3, NULL) || (len2 != len3)) {
			return 1; /* s */
		}
	}
	return 0; /*  */
}

static int ismAppCtrl(long stat) {
	int err;
	if((err = ismSetAppStat(stat)) == 0) {
		int t = GetTickCount();
		stat = (stat + 1) & 3; /* 1 -> 2, 3 -> 0 */
		for(;;) {
			int a;
			if((err = ismGetAppStat(&a)) != 0) {
				break; /* s */
			}
			if(a == stat) {
				break; /*  */
			}
			if((GetTickCount() - t) >= 1000) {
				printf("Time Out\n");
				err = ERR_PIECEIF_TIMEOUT; /* ^CAEg */
				break;
			}
			Sleep(20);
		}
	}
	return err;
}

int DLLAPI ismAppStart() {
	return ismAppCtrl(1);
}

int DLLAPI ismAppStop() {
	return ismAppCtrl(3);
}

static int readfile_srf(FILE* fp) {
	unsigned char tmp[64];
	unsigned long next;
	if(fread(tmp, 1, 16, fp) != 16) { /* srf33wb_ */
		return 2; /* s */
	}
	if((*(unsigned short*)tmp | 0x0008) != 0x000E) { /* t@CtO */
		return 3; /* s */
	}
	printf("\n");
	next = *(unsigned long*)&tmp[8]; /* ZNV`F[ */
	while(next) {
		unsigned long len;
		fseek(fp, next, SEEK_SET);
		if(fread(tmp, 1, 44, fp) != 44) { /* ZNV */
			return 4; /* s */
		}
		next = *(unsigned long*)tmp; /* ̃ZNVւ̃`F[ */
		len = *(unsigned long*)&tmp[38]; /* f[^oCgTCY */
		if(len) {
			unsigned long adr = *(unsigned long*)&tmp[10]; /* ZNṼX^[gAhX */
			unsigned long pos = *(unsigned long*)&tmp[34]; /* f[^ւ̃`F[ */
			if(pos) {
				printf("  %06x-%06x\n", adr, adr + len - 1);
				fseek(fp, pos, SEEK_SET);
				while(len) {
					unsigned char tbuff[32 * 1024];
					unsigned long len2 = len;
					int err;
					if(len2 > sizeof tbuff) {
						len2 = sizeof tbuff;
					}
					if(fread(tbuff, 1, len2, fp) != len2) {
						return 5; /* s */
					}
					if((err = ismWriteMem(tbuff, adr, len2)) != 0) {
						return err; /* s */
					}
					adr += len2;
					len -= len2;
				}
			}
		}
	}
	return 0; /*  */
}

int DLLAPI ismWriteSrfFile(const char* infname, int run) {
	int err = 1; /* s */
	FILE* fp = fopen(infname, "rb");
	if(fp) {
		if(run) {
			ismAppStop();
		}
		err = readfile_srf(fp);
		if(run) {
			ismAppStart();
		}
		fclose(fp);
	}
	return err;
}

int DLLAPI ismLCDCaptureScreen(unsigned char* buff, int len) {
	int err;
	if((err = ismAppPause(1)) == 0) {
		int t = GetTickCount();
		for(;;) {
			int f;
			unsigned long vbuff;
			if((err = ismLCDGetInfo(&f, &vbuff)) != 0) {
				break; /* s */
			}
			if(f) {
				if((err = ismReadMem(buff, vbuff, len)) == 0) {
					break; /*  */
				}
			}
			if((GetTickCount() - t) >= 1000) {
				printf("Time Out\n");
				err = ERR_PIECEIF_TIMEOUT; /* ^CAEg */
				break;
			}
			Sleep(20);
		}
		ismAppPause(0);
	}
	return err;
}

/****************************************************************************
 *	
 ****************************************************************************/

#define MSBLKADR PFFSTOP

static pffsMASTERBLOCK msblk;
static unsigned long PFFSTOP;
static unsigned long PFFSEND;
static int MAXFAT2;

/*--------------------------------------------------------------------------*/

static int flash_write(unsigned long adr, void* ptr, unsigned long len) {
	int err;
	int a;
	if((err = ismWriteMem(ptr, 0x130000, len)) != 0) {
		return err; /* s */
	}
	if((err = ismFlashErase(adr, &a)) != 0) {
		return err; /* s */
	}
	if(a) {
		return a; /* s */
	}
	if((err = ismFlashWrite(adr, 0x130000, len, &a)) != 0) {
		return err; /* s */
	}
	return a;
}

static int ffs_loaddir() {
	SYSTEMINFO si;
	if(ismGetVersion(&si, 0) == PIECE_INVALID_VERSION) {
		return 1; /* s */
	}
	PFFSTOP = (unsigned long)si.pffs_top;
	PFFSEND = (unsigned long)si.pffs_end;
	MAXFAT2 = (PFFSEND - PFFSTOP) >> 12;
	if(MAXFAT2 > MAXFAT) {
		MAXFAT2 = MAXFAT;
	}
	return ismReadMem((unsigned char*)&msblk, MSBLKADR, sizeof(pffsMASTERBLOCK));
}

static int ffs_savedir() {
	return flash_write(MSBLKADR, &msblk, sizeof(pffsMASTERBLOCK));
}

static DIRECTORY* ffs_srchdir(const char* name) {
	int i;
	DIRECTORY* pdir;
	for(i = 0, pdir = msblk.dir; i < MAXDIR; i++, pdir++) {
		unsigned char a = pdir->name[0];
		if((a != 0) && (a != 0xFF)) {
			if(!strcmp(pdir->name, name)) {
				return pdir;
			}
		}
	}
	return NULL;
}

static DIRECTORY* ffs_freedir() {
	int i;
	DIRECTORY* pdir;
	for(i = 0, pdir = msblk.dir; i < MAXDIR; i++, pdir++) {
		unsigned char a = pdir->name[0];
		if((a == 0) || (a == 0xFF)) {
			return pdir;
		}
	}
	return NULL;
}


static void ffs_delete(DIRECTORY* pdir) {
	int n = pdir->chain;
	memset(pdir, 0xFF, sizeof(DIRECTORY));
	while(n < MAXFAT2) {
		int n1 = msblk.fat[n].chain;
		msblk.fat[n].chain = FAT_FREE;
		n = n1;
	}
}

static int ffs_read(DIRECTORY* pdir, FILE* fp) {
	unsigned char tbuff[1 << 12];
	unsigned len = pdir->size;
	int n = pdir->chain;
	while(len && (n < MAXFAT2)) {
		int n1 = msblk.fat[n].chain;
		unsigned len0 = len;
		if(len0 > (1 << 12)) {
			len0 = (1 << 12);
		}
		if(ismReadMem(tbuff, PFFSTOP + (n << 12), len0)) {
			break; /* s */
		}
		if(fwrite(tbuff, 1, len0, fp) != len0) {
			break; /* s */
		}
		n = n1;
		len -= len0;
	}
	return len;
}

static int ffs_save(const char* name, unsigned char* pdata, int len) {
	unsigned short tbl[MAXFAT];
	int len2;
	int len3;
	int i;
	int n;
	DIRECTORY* pdir;
	if(!len) {
		return 1; /* s */
	}
	len2 = (len + ((1 << 12) - 1)) >> 12;
	/* Õt@CL폜 */
	pdir = ffs_srchdir(name);
	if(pdir) {
		ffs_delete(pdir);
	}
	/* 󂫃fBNgGg擾 */
	pdir = ffs_freedir();
	if(!pdir) {
		printf("fBNg܂B\n");
		return ERR_PIECEIF_PFFS_DIR_EMPTY;
	}
	/* 󂫃ZN^`FC擾 */
	i = 0;
	for(n = 0; n < MAXFAT2; n++) {
		if(msblk.fat[n].chain == FAT_FREE) {
			tbl[i++] = n;
			if(i == len2) {
				break;
			}
		}
	}
	if(i < len2) {
		printf("󂫂܂B\n");
		return ERR_PIECEIF_PFFS_EMPTY;
	}
	/* fBNgGg쐬 */
	memset(pdir, 0, sizeof(DIRECTORY));
	strcpy(pdir->name, name);
	pdir->size = len;
	pdir->chain = tbl[0];
	/* ZN^`FC쐬 */
	i = 0;
	do {
		len3 = len;
		if(len3 > (1 << 12)) {
			len3 = (1 << 12);
		}
		n = tbl[i++];
		if(flash_write(PFFSTOP + (n << 12), pdata, len3)) {
			return 4; /* s */
		}
		msblk.fat[n].chain = (i < len2) ? tbl[i] : FAT_END;
		pdata += len3;
	} while(len -= len3);
	return 0; /*  */
}

static int check_fname(const char* p) {
	int i;
	for(i = 0; i < 2; i++) { /* 0 = x[X, 1 = gq */
		int c = 0;
		char a;
		for(;;) {
			a = *p++;
			if(!(isdigit(a) || islower(a) || (a == '_'))) { /* [0-9a-z_] */
				break;
			}
			c++;
		}
		if(i == 0) {
			if((c == 0) || (c > 8)) { /* x[X1`8łȂ */
				return 1; /* s */
			}
		} else {
			if((c == 0) || (c > 3)) { /* gq1`3łȂ */
				return 3; /* s */
			}
		}
		if(!a) {
			return 0; /*  */
		}
		if(a != '.') {
			return 2; /* s */
		}
	}
	return 4; /* gqȏL */
}

int DLLAPI ismPFFSWrite(const char *fname, const char *infname) {
	int err = 1; /* s */
	FILE* fp;
	if(check_fname(fname)) {
		return ERR_PIECEIF_PFFS_BAD_FAILENAME; /* PFFS̃t@Cs */
	}
	fp = fopen(infname, "rb");
	if(fp) {
		int len;
		unsigned char* xbuff;
		fseek(fp, 0, SEEK_END);
		len = ftell(fp);
		rewind(fp);
		xbuff = malloc(len);
		if(xbuff) {
			fread(xbuff, 1, len, fp);
			if(!ismAppStop()) {
				if(!ffs_loaddir()) {
					err = ffs_save(fname, xbuff, len);
					if(!err) {
						err = ffs_savedir();
					}
				}
				ismAppStart();
			}
			free(xbuff);
		}
		fclose(fp);
	}
	return err;
}

int DLLAPI ismPFFSRead(const char *fname,  const char *outfname) {
	int err = 1; /* s */
	if(!ffs_loaddir()) {
		DIRECTORY* pdir = ffs_srchdir(fname);
		if(pdir) {
			FILE* fp = fopen(outfname, "wb");
			if(fp) {
				printf("reading '%s'", fname);
				err = ffs_read(pdir, fp);
				printf(" done\n");
				fclose(fp);
			}
		}
	}
	return err;
}

int DLLAPI ismPFFSDelete(const char* fname) {
	int err = 1; /* s */
	if(!ismAppStop()) {
		if(!ffs_loaddir()) {
			DIRECTORY* pdir = ffs_srchdir(fname);
			if(pdir) {
				ffs_delete(pdir);
				err = ffs_savedir();
			}
		}
		ismAppStart();
	}
	return err;
}

int DLLAPI ismPFFSInit() {
	int err = 1; /* s */
	if(!ffs_loaddir()) {
		static const char sig[24] = "PFFS Master Block";
		int n;
		memset(&msblk, 0xFF, sizeof(pffsMASTERBLOCK));
		memcpy(msblk.mark.signature, sig, 24);
		msblk.mark.ptr = MSBLKADR + 4; /* IWi\[XǂBprs */
		msblk.fat[0].chain = FAT_SYSTEM;
		for(n = MAXFAT2; n < MAXFAT; n++) {
			msblk.fat[n].chain = FAT_INVALID;
		}
		if(!ismAppStop()) {
			err = ffs_savedir();
			ismAppStart();
		}
	}
	return err;
}

int DLLAPI ismPFFSDir(char* buff, unsigned len, int flag) {
	char tmp[256];
	int c = 0;
	int i;
	int n;
	DIRECTORY* pdir;
	if(ffs_loaddir()) {
		return 1; /* s */
	}
	/* t@CXg */
	for(i = 0, pdir = msblk.dir; i < MAXDIR; i++, pdir++) {
		unsigned char a = pdir->name[0];
		if((a != 0) && (a != 0xFF)) {
			n = sprintf(tmp, "+%3d:%6d %s\n", i, pdir->size, pdir->name);
			if(n > (int)len) {
				return 1; /* s */
			}
			memcpy(buff, tmp, n);
			buff += n;
			len -= n;
		}
	}
	/* JZN^ */
	for(i = 0; i < MAXFAT2; i++) {
		if(msblk.fat[i].chain == FAT_FREE) {
			c++;
		}
	}
	n = sprintf(tmp, "    %d sectors (%d bytes) free\n", c, (c << 12)) + 1/*nul*/;
	if(n > (int)len) {
		return 1; /* s */
	}
	memcpy(buff, tmp, n);
	return 0; /*  */
}

